//This header is responsible for including all the other and defining some symbols to ease the developpement
#ifndef _HATP_MSGS_H_
#define _HATP_MSGS_H_

#include <iostream>
#include <map>

#include <ros/ros.h>

#include <hatp_msgs/constants.h>

//Messages
#include <hatp_msgs/StreamNode.h>
#include <hatp_msgs/Plan.h>
#include <hatp_msgs/Request.h>
#include <hatp_msgs/Task.h>
#include <hatp_msgs/TreeNode.h>

#include <hatp_msgs/Attribute.h>
#include <hatp_msgs/Entity.h>
#include <hatp_msgs/WorldBase.h>

#include <hatp_msgs/TaskDescription.h>

//Services
#include <hatp_msgs/PlanningRequest.h>

#include <hatp_msgs/FactDatabaseRequest.h>
#include <hatp_msgs/HTNDatabaseRequest.h>

#include <hatp_msgs/SetMaxtime.h>
#include <hatp_msgs/GetMaxtime.h>

//Tools to transform the ROS message into something more usable
#include <libhatp/hatpPlan.h>
#include <libhatp/hatpStream.h>
#include <libhatp/hatpTask.h>
#include <libhatp/hatpTaskList.h>
#include <libhatp/hatpTree.h>

#endif //_HATP_MSGS_H_
