#ifndef _HATPPLAN_H_
#define _HATPPLAN_H_

#include <hatp_msgs/Task.h>
#include <hatp_msgs/StreamNode.h>
#include <hatp_msgs/TreeNode.h>
#include <hatp_msgs/Plan.h>

#include <libhatp/hatpTaskList.h>
#include <libhatp/hatpTree.h>
#include <libhatp/hatpStream.h>

class hatpPlan{
private:
	unsigned int id;
	std::string report;

	hatpTaskList* tasks;
	std::vector<std::string> agents;
	
	hatpTree* tree;
	
	hatpStream* streams;

public:
	hatpPlan(const hatp_msgs::Plan&);
	hatpPlan(const hatp_msgs::Plan::ConstPtr&);
	
	std::string toString() const;
	
	std::string getReport() const;
	bool isReportOK() const;
	bool isValid() const; //Alias to isReportOK()
	
	bool hasTask(unsigned int id) const;
	hatpTaskPtr getTask(unsigned int id) const;
	hatpTaskList& getTaskList();
	hatpTaskList const& getTaskList() const;
	
	std::vector<std::string> getAgentsList() const;
	
	hatpStream* getStreams();
	
	hatpTree* getTree();
	
	~hatpPlan();
};

#endif //_HATPPLAN_H_
