#ifndef _HATPSTREAM_H_
#define _HATPSTREAM_H_

#include <vector>

#include <hatp_msgs/StreamNode.h>

#include <libhatp/hatpTask.h>

class hatpPlan;

class hatpStream{
private:
	hatpPlan& plan;
	
	std::map< std::string, hatpTaskSet > streams;
	
	std::map<unsigned int, int> ranks; //<task, rank>
	int maxRank;
	void computeNodeRank(hatpTaskPtr cnode);

public:
	hatpStream(hatpPlan& plan, std::vector<hatp_msgs::StreamNode> const& streams);
	
	int getRankOfNode(unsigned int n) const;
	hatpTaskSet getNodesOfRank(int n) const;
	unsigned int getMaxRank() const;
	
	hatpTaskSet const& getStreamForAgent(std::string const& agent) const;
	std::map< std::string, hatpTaskSet > const& getAgentsStreams() const;

	std::string toString() const;
};

#endif //_HATPSTREAM_H_
